<template>
    <div id="historias-carrusel" class="carousel slide pb-4 carousel-container" data-bs-ride="carousel"
        data-interval="false" v-if="usuario">
        <div class="carousel-inner">
            <div class="carousel-item" v-for="(slide, index) in Math.ceil(listadoHistorias.length / 4)" :key="index"
                :class="{ 'active': index === 0 }">
                <div class="row">
                    <div class="col-md-3" v-for="(historia, cardIndex) in dividirPorSlide(slide)" :key="cardIndex"
                        :class="{ 'primer-objeto': historia.esPrimerObjeto }">
                        <div class="card border-0">
                            <div class="card-img-wrapper">

                                <div v-if="!historia.esPrimerObjeto">
                                    <img id="icono" :src="fotoPerfil">
                                    <img :src="historia.imagen" alt="Imagen" id="vistaPrevia" class="card-img"
                                        @click="mostrarModalHistorias(historia.imagen)">
                                    <div class="card-footer border-0 text-white">
                                        {{ usuario.nombreUsuario }}
                                    </div>
                                </div>

                                <div v-if="historia.esPrimerObjeto">
                                    <div class="primer-objeto-wrapper">
                                        <img :src="fotoPerfil" alt="Imagen" id="agregarHistoria" class="card-img">
                                        <div class="icono-wrapper">
                                            <i class="bi bi-plus-circle-dotted" @click="mostrarModalSubirHistorias"></i>
                                        </div>
                                        <div class="card-footer border-0 text-white">
                                            Agregar historia
                                        </div>
                                    </div>
                                </div>

<!-- Modal para subir historias -->
<div id="modalSubirHistorias" v-if="mostrarModalSubirHistoria" class="modal">
  <v-dialog v-model="mostrarModalSubirHistoria" max-width="500px">
    <v-card>
      <v-toolbar dense color="primary" dark>
        <v-btn icon @click="cerrarModalSubirHistoria">
          <v-icon>mdi-close</v-icon>
        </v-btn>
        <v-toolbar-title>Subir Historia</v-toolbar-title>
      </v-toolbar>
      <v-card-text>
        <form @submit.prevent="submitForm">
          <div class="opciones-container">
            <div class="opcion" @click="elegirOpcion('imagen')">
              <v-btn icon small>
                <v-icon>mdi-image</v-icon>
              </v-btn>
              <span>Imagen</span>
            </div>

            <div class="opcion pb-2" @click="elegirOpcion('video')">
              <v-btn icon small>
                <v-icon>mdi-video</v-icon>
              </v-btn>
              <span>Video</span>
            </div>
          </div>

          <div class="text-center">
            <div v-if="selecionado === 'imagen'" class="pb-2">
              <label for="archivoImagen" class="pb-2">Selecciona una imagen:</label>
              <input type="file" id="archivoImagen" accept="image/*" @change="subirImagen">
            </div>

            <div v-if="selecionado === 'video'" class="pb-2">
              <label for="archivoVideo" class="pb-2">Selecciona un video:</label>
              <input type="file" id="archivoVideo" accept="video/*" @change="subirVideo">
            </div>

            <v-btn v-if="selecionado" type="submit" color="primary">Subir</v-btn>
          </div>
        </form>
      </v-card-text>
    </v-card>
  </v-dialog>
</div>


                            </div>
                        </div>

                    </div>
                </div>
            </div>
        </div>

        <button class="carousel-control-prev" type="button" data-bs-target="#historias-carrusel" data-bs-slide="prev">
            <span class="carousel-control-prev-icon" aria-hidden="true"></span>
            <span class="visually-hidden">Anterior</span>
        </button>
        <button class="carousel-control-next" type="button" data-bs-target="#historias-carrusel" data-bs-slide="next">
            <span class="carousel-control-next-icon" aria-hidden="true"></span>
            <span class="visually-hidden">Siguiente</span>
        </button>
    </div>



    <!--modal -->
    <div id="modalHistorias">
        <div class="container" id="contenido-modal-historias">
            <div class="row h-100">
                <div class="col-12 h-100">
                    <div class="row h-100 p-3">
                        <div class="col-12 h-100" id="contenedor-foto-perfil-portada-modal">
                            <div class="text-white" id="botonCerrar" @click="ocultarModalHistorias">Cerrar</div>
                            <img src="" id="imagenCompleta">
                            <div class="container-fluid" id="modal-foto-perfil-portada-texto">
                                <div class="row">
                                    <div class="col-12">
                                        <p></p>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</template>

<script>
import axios from 'axios';
import { buscarImagenDePerfilDeUnUsuario } from "@/Services/muro/MuroService.js"

//v-if="historiaSeleccionada"

export default {
    name: "CarruselHistorias",
    data() {
        return {
            usuario: null,
            listadoHistorias: [],
            muro: null,
            fotoPerfil: null,

            mostrarModalSubirHistoria: false,
            modalImage: '',
            modalText: '',
            selecionado: null,
            archivoImagen: null,
            archivoVideo: null,
        }
    },

    methods: {
        mostrarModalSubirHistorias() {
            try {
                this.mostrarModalSubirHistoria = true,
                    document.getElementById('modalSubirHistorias').style.display = 'block';
            } catch (error) {
                console.log(error)
            }
        },

        ocultarModalSubirHistorias() {

            try {
                this.mostrarModalSubirHistoria = false,
                    document.getElementById('modalSubirHistorias').style.display = 'none';
            } catch (error) {
                console.log(error)
            }


        },

        elegirOpcion(opcion) {
        this.selecionado = opcion;
    },


        mostrarModalHistorias(historia) {
            document.getElementById('imagenCompleta').src = historia;
            let modal = document.getElementById("modalHistorias");
            let contenido = document.getElementById("contenido-modal-historias");
            modal.style.display = "block";


            setTimeout(() => {
                modal.style.background = "rgba(0, 0, 0, 0.65)";
                contenido.style.opacity = "100%";
                modal.style.setProperty("backdrop-filter", "blur(10px)");
            }, 0);
        },

        ocultarModalHistorias() {
            let modal = document.getElementById("modalHistorias");
            let contenido = document.getElementById("contenido-modal-historias");
            modal.style.setProperty("backdrop-filter", "blur(0px)");
            modal.style.background = "rgba(0, 0, 0, 0)";
            contenido.style.opacity = "0";

            setTimeout(() => {
                modal.style.display = "none";
            }, 100)
        },

        async cargarUsuario() {
            try {
                const data = await axios.get("http://localhost:3001/usuarios/sesion");
                this.usuario = data.data;
                console.log(this.usuario)
            } catch (e) {
                console.log(e);
            }
        },

        async buscarHistoria() {
            console.log("id usuario" + this.usuario.id)
            if (this.usuario?.id) {
                await axios
                    .get(`http://localhost:3001/h/historias_id?id_historia=${this.usuario.id}`)
                    .then((response) => {
                        this.historiaSeleccionada = response.data;
                        console.log("respuesta historias: " + response.data);
                    })
                    .catch((error) => {
                        console.error(error);
                    });
            }
        },

        async buscarTodasLasHistorias() {
            try {
                console.log(this.usuario);
                let res = await axios.get(`http://localhost:3001/h/historias_muro_id?id_muro=${this.usuario.id}`);
                this.listadoHistorias = res.data;
                console.log("listadoHistorias")
                console.log(this.listadoHistorias)
                this.listadoHistorias.unshift({ foto: this.usuario.foto, esPrimerObjeto: true });
            } catch (error) {
                console.log(error);
            }
        },

        dividirPorSlide(slideIndex) {
            const startIndex = (slideIndex - 1) * 4;
            const endIndex = slideIndex * 4;
            return this.listadoHistorias.slice(startIndex, endIndex);
        },
        async buscarMuro() {
            let muro = null;
            try {
                const response = await axios.get(`http://localhost:3001/muro/ver/${this.id}`);
                muro = response.data;
            } catch (e) {
                console.log(e);
            }
            this.muro = muro;

        },
        async buscarFotoPerfil() {
            try {
                this.fotoPerfil = await buscarImagenDePerfilDeUnUsuario(this.usuario);

            } catch (e) {
                console.log(e)
            }
        },

        cerrarModalSubirHistoria() {
            this.mostrarModalSubirHistoria = false;
        },

        subirImagen(event) {
            try {
                this.archivoImagen = event.target.files[0];
            } catch (error) {
                
            }
        },

        subirVideo(event) {
            try {
                this.archivoVideo = event.target.files[0];
            } catch (error) {
                
            }
        },
        

        submitForm() {
            console.log('Tipo seleccionado:', this.seleccionado);
            console.log('Archivo de imagen:', this.archivoImagen);
            console.log('Archivo de video:', this.archivoVideo);
            this.mostrarModalSubirHistoria = false;
        },
    },
    async created() {
        await this.cargarUsuario();
        await this.buscarMuro();
        await this.buscarTodasLasHistorias();
        await this.buscarFotoPerfil();
    }
}
</script>

<style scoped>
.card {
    position: relative;
    background-color: transparent;
    height: 200px;
    cursor: pointer;
}

.card-img-wrapper {
    border-radius: 5%;
}

.card-img-wrapper img {
    height: 200px;
    background-repeat: no-repeat;
    object-fit: cover;
    width: 100%;
    max-width: 100%;
    overflow: hidden;

}

.card-footer {
    position: absolute;
    bottom: 0;
    left: 0;
    right: 0;
    background-color: transparent;
    color: white;
    padding: 10px;
}


#icono {
    border-radius: 50%;
    border: 3px solid #3877e1;
    background-repeat: no-repeat;
    background-size: cover;
    width: 45px;
    height: 45px;
    margin: 5px;
    position: absolute;

}

/* Modal */
#modalHistorias,
#modalSubirHistorias {
    display: none;
    position: fixed;
    transition: background-color .2s;
    height: 100vh;
    width: 100%;
    top: 0;
    left: 0;
    z-index: 100;
}

#modalHistorias-container,
#modalSubirHistorias-container {
    opacity: 0;
    transition: opacity .2s;

}

#modalHistorias-botonCerrar {
    color: white;
    position: fixed;
    margin: 10px;
    width: 50px;
    height: 50px;
    top: 0;
    right: 0;
    z-index: 200;
    cursor: pointer;
}

#imagenCompleta {

    height: 600px;
    width: 400px;
    background-repeat: no-repeat;
    object-fit: cover;
    max-width: 100%;
    overflow: hidden;
}

.primer-objeto-wrapper {
    position: relative;
}

.icono-wrapper {
    position: absolute;
    top: 50%;
    left: 50%;
    transform: translate(-50%, -50%);
}

.icono-wrapper i {
    font-size: 60px;
}

#agregarHistoria {
    opacity: 50%;
}


.opciones-container {
  display: flex;
  justify-content: center;
  gap: 100px;
}

.opcion {
  display: flex;
  flex-direction: column;
  align-items: center;
  font-size: 12px;
}

/* otros estilos carrusel */

.carousel .carousel-control-prev-icon {
    background-image: url('data:image/svg+xml,<svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="%234d6dcf" class="bi bi-arrow-left-circle-fill" viewBox="0 0 16 16"><path d="M8 0a8 8 0 1 0 0 16A8 8 0 0 0 8 0zm-3.5 7.5a.5.5 0 0 1 0 1H5.707l2.147 2.146a.5.5 0 0 1-.708.708l-3-3a.5.5 0 0 1 0-.708l3-3a.5.5 0 1 1 .708.708L5.707 7.5H11.5z"/></svg>');
}


.carousel .carousel-control-next-icon {
    background-image: url('data:image/svg+xml,<svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="%234d6dcf" class="bi bi-arrow-right-circle-fill" viewBox="0 0 16 16"><path d="M8 0a8 8 0 1 1 0 16A8 8 0 0 1 8 0zM4.5 7.5a.5.5 0 0 0 0 1h5.793l-2.147 2.146a.5.5 0 0 0 .708.708l3-3a.5.5 0 0 0 0-.708l-3-3a.5.5 0 1 0-.708.708L10.293 7.5H4.5z"/></svg>');
}


.carousel-control-next-icon,
.carousel-control-prev-icon {
    width: 3rem;
    height: 3rem;
}

.carousel-container {
    position: relative;
}

.carousel-control-prev,
.carousel-control-next {
    position: absolute;
    top: 50%;
    transform: translateY(-50%);
    z-index: 1;
}

.carousel-control-prev {
    left: -50px;
}

.carousel-control-next {
    right: -50px;
}</style>